try {
    var test;
    var sample= null;
    totalPageNum = 1;
    var navUserAgent = navigator.userAgent;
    var readability = {
    }
    var readerPage = null;
    parsedPages= {};
    pageETags = {};
    var isTTSSupported = "true";
    var all_images_data_map_height ={};
    var all_images_data_map_width = {};
    var flag_to_add_weight = true;
    function findBaseUrl() {
        var noUrlParams     = window.location.pathname.split("?")[0],
                urlSlashes      = noUrlParams.split("/").reverse(),
                cleanedSegments = [],
                possibleType    = "";
        for (var i = 0, slashLen = urlSlashes.length; i < slashLen; i+=1) {
            var segment = urlSlashes[i];
            if (segment.indexOf(".") !== -1) {
                possibleType = segment.split(".")[1];
                if(!possibleType.match(/[^a-zA-Z]/)) {
                    segment = segment.split(".")[0];
                }
            }
            if(segment.indexOf(',00') !== -1) {
                segment = segment.replace(',00', '');
            }
            if (segment.match(/((_|-)?p[a-z]*|(_|-))[0-9]{1,2}$/i) && ((i === 1) || (i === 0))) {
                segment = segment.replace(/((_|-)?p[a-z]*|(_|-))[0-9]{1,2}$/i, "");
            }
            var del = false;
            if (i < 2 && segment.match(/^\d{1,2}$/)) {
                del = true;
            }
            if(i === 0 && segment.toLowerCase() === "index") {
                del = true;
            }
            if(i < 2 && segment.length < 3 && !urlSlashes[0].match(/[a-z]/i)) {
                del = true;
            }
            if (!del) {
                cleanedSegments.push(segment);
            }
        }
        return window.location.protocol + "//" + window.location.host + cleanedSegments.reverse().join("/");
    }
    function findNextPageLink(elem) {
        var possiblePages = {},
                allLinks = elem.getElementsByTagName('a'),
                articleBaseUrl = findBaseUrl();
        for(var i = 0, il = allLinks.length; i < il; i+=1) {
            var link     = allLinks[i],
                    linkHref = allLinks[i].href.replace(/#.*$/, '').replace(/\/$/, '');
            if(linkHref === "" || linkHref === articleBaseUrl || linkHref === window.location.href || linkHref in parsedPages) {
                continue;
            }
            if(window.location.host !== linkHref.split(/\/+/g)[1]) {
                continue;
            }
            if(link.rel.indexOf("noindex") > -1){
                continue;
            }
            var linkText = getInnerText(link);
            if(linkText.match(regexps.extraneous)) {
                continue;
            }
            var linkHrefLeftover = linkHref.replace(articleBaseUrl, '');
            if(!linkHrefLeftover.match(/\d/)) {
                continue;
            }
            if(!(linkHref in possiblePages)) {
                possiblePages[linkHref] = {"score": 0, "linkText": linkText, "href": linkHref};
            } else {
                possiblePages[linkHref].linkText += ' | ' + linkText;
            }
            var linkObj = possiblePages[linkHref];
            if(linkHref.indexOf(articleBaseUrl) !== 0) {
                linkObj.score -= 25;
            }
            var linkData = linkText + ' ' + link.className + ' ' + link.id + link.innerHTML;
            if(linkData.match(regexps.nextLink)) {
                linkObj.score += 50;
            }
            if(linkData.match(/pag(e|ing|inat)/i)) {
                linkObj.score += 25;
            }
            if(linkData.match(/(first|last)/i)) {
                if(!linkObj.linkText.match(regexps.nextLink)) {
                    linkObj.score -= 65;
                }
            }
            if(linkData.match(regexps.negative) || linkData.match(regexps.extraneous)) {
                linkObj.score -= 50;
            }
            if(linkData.match(regexps.prevLink)) {
                linkObj.score -= 200;
            }
            var parentNode = link.parentNode,
                    positiveNodeMatch = false,
                    negativeNodeMatch = false;
            while(parentNode) {
                var parentNodeClassAndId = parentNode.className + ' ' + parentNode.id;
                if(!positiveNodeMatch && parentNodeClassAndId && parentNodeClassAndId.match(/pag(e|ing|inat)/i)) {
                    positiveNodeMatch = true;
                    linkObj.score += 15;
                }
                if(!negativeNodeMatch && parentNodeClassAndId && parentNodeClassAndId.match(regexps.negative)) {
                    if(!parentNodeClassAndId.match(regexps.positive)) {
                        linkObj.score -= 25;
                        negativeNodeMatch = true;
                    }
                }
                parentNode = parentNode.parentNode;
            }
            if (linkHref.match(/p(a|g|ag)?(e|ing|ination)?(=|\/)[0-9]{1,2}/i) || linkHref.match(/(page|paging)/i)) {
                linkObj.score += 25;
            }
            if (linkHref.match(regexps.extraneous)) {
                linkObj.score -= 15;
            }
            var linkTextAsNumber = parseInt(linkText, 10);
            if(linkTextAsNumber) {
                if (linkTextAsNumber === 1) {
                    linkObj.score -= 10;
                }
                else {
                    linkObj.score += Math.max(0, 10 - linkTextAsNumber);
                }
            }
        }
        var topPage = null;
        for(var page in possiblePages) {
            if(possiblePages.hasOwnProperty(page)) {
                if(possiblePages[page].score > 100 && (!topPage || topPage.score < possiblePages[page].score)) {
                    topPage = possiblePages[page];
                }
            }
        }
        if(topPage) {
            var nextHref = topPage.href.replace(/\/$/,'');
            parsedPages[nextHref] = true;
            return nextHref;
        }
        else {
            return null;
        }
    }
    function xhr() {
        if (typeof XMLHttpRequest !== 'undefined' && (window.location.protocol !== 'file:' || !window.ActiveXObject)) {
            return new XMLHttpRequest();
        }
        else {
            try { return new ActiveXObject('Msxml2.XMLHTTP.6.0'); } catch(sixerr) { }
            try { return new ActiveXObject('Msxml2.XMLHTTP.3.0'); } catch(threrr) { }
            try { return new ActiveXObject('Msxml2.XMLHTTP'); } catch(err) { }
        }
        return false;
    }
    function successfulRequest(request) {
        return (request.status >= 200 && request.status < 300) || request.status === 304 || (request.status === 0 && request.responseText);
    }
    function ajax(url, options) {
        var request = xhr();
        function respondToReadyState(readyState) {
            if (request.readyState === 4) {
                if (successfulRequest(request)) {
                    if (options.success) { options.success(request); }
                }
                else {
                    if (options.error) { options.error(request); }
                }
            }
        }
        if (typeof options === 'undefined') { options = {}; }
        request.onreadystatechange = respondToReadyState;
        request.open('get', url, true);
        request.setRequestHeader('Accept', 'text/html');
        try {
            request.send(options.postBody);
        }
        catch (e) {
            if (options.error) { options.error(); }
        }
        return request;
    }
    curPageNum = 1;
    maxPages =  30;
    function appendNextPage(nextPageLink) {
        curPageNum+=1;
        var articlePage       = document.createElement("DIV");
        articlePage.id        = 'readability-page-' + curPageNum;
        articlePage.className = 'BSB_page';
        articlePage.innerHTML = '<p class="BSB_page-separator" title="Page ' + curPageNum + '">Page '+curPageNum+'</p>';
        if(curPageNum > maxPages) {
            var nextPageMarkup = "<div style='text-align: center'><a href='" + nextPageLink + "'>View Next Page</a></div>";
            articlePage.innerHTML = articlePage.innerHTML + nextPageMarkup;
            return;
        }
        (function(pageUrl, thisPage) {
            ajax(pageUrl, {
                success: function(r) {
                var eTag = r.getResponseHeader('ETag');
                if(eTag) {
                    if(eTag in pageETags) {
                        dbg("Exact duplicate page found via ETag. Aborting.");
                        articlePage.style.display = 'none';
                        return;
                    } else {
                        pageETags[eTag] = 1;
                    }
                }
                var page = document.createElement("DIV");
                var responseHtml = r.responseText.replace(/\n/g,'\uffff').replace(/<script.*?>.*?<\/script>/gi, '');
                responseHtml = responseHtml.replace(/\n/g,'\uffff').replace(/<script.*?>.*?<\/script>/gi, '');
                responseHtml = responseHtml.replace(/\uffff/g,'\n').replace(/<(\/?)noscript/gi, '<$1div');
                responseHtml = responseHtml.replace(regexps.replaceBrs, '</p><p>');
                responseHtml = responseHtml.replace(regexps.replaceFonts, '<$1span>');
                page.innerHTML = responseHtml;
                flags = 0x1 | 0x2 | 0x4;
                var nextPageLink = findNextPageLink(page),
                        content      =  grabArticle(page);
                if(!content) {
                    return;
                }
                thisPage.innerHTML += content;
                document.getElementById("reader_content_div").appendChild(thisPage);
                if(nextPageLink) {
                    appendNextPage(nextPageLink);
                }
            }
            });
        }(nextPageLink, articlePage));
    }
    regexps = {
        unlikelyCandidates:    /adfdb|combx|comment|community|disqus|extra|foot|header|menu|remark|rss|shoutbox|sidebar|sponsor|ad-break|agegate|pagination|pager|popup|tweet|twitter|rmcplayer|u_rmcplayer|video_area/i,
        okMaybeItsACandidate:  /and|article|body|column|main|shadow/i,
        positive:              /article|body|content|entry|hentry|main|page|pagination|post|text|blog|story|windowclassic/i,
        negative:              /adfdb|contents|combx|comment|com-|contact|foot|footer|footnote|masthead|media|meta|outbrain|promo|related|scroll|shoutbox|sidebar|date|sponsor|shopping|tags|script|tool|widget|scbox|rail|reply|div_dispalyslide|galleryad|disqus_thread|cnn_strylftcntnt|topRightNarrow|fs-stylelist-thumbnails|replText|ttalk_layer|disqus_post_message|disqus_post_title|cnn_strycntntrgt|wpadvert|sharedaddy sd-like-enabled sd-sharing-enabled|fs-slideshow-wrapper|fs-stylelist-launch|fs-stylelist-next|fs-thumbnail-194230|reply_box|textClass errorContent|mainHeadlineBrief|mainSlideDetails|curvedContent|photo|home_|XMOD|welcome-text/i,
        extraneous:            /print|archive|comment|discuss|e[\-]?mail|share|reply|all|login|sign|single/i,
            divToPElements:        /<(a|blockquote|dl|div|img|ol|p|pre|table|ul|script|article|form|select)/i,
            replaceBrs:            /(<br[^>]*>[ \n\r\t]*){2,}/gi,
            replaceFonts:          /<(\/?)font[^>]*>/gi,
            trim:                  /^\s+|\s+$/g,
            normalize:             /\s{2,}/g,
            killBreaks:            /(<br\s*\/?>(\s|&nbsp;?)*){1,}/g,
            videos:                /http:\/\/(www\.)?(youtube|vimeo)\.com/i,
                images:                /(file:\/\/\/android_asset\/video_play.png|http:\/\/i2.ytimg.com\/vi\/)/i,
                skipFootnoteLink:      /^\s*(\[?[a-z0-9]{1,2}\]?|^|edit|citation needed)\s*$/i,
                nextLink:              /(next|right|weiter|continue|>([^\|]|$)|\u00BB([^\|]|$))/i,
                prevLink:              /(prev|earl|old|<|«)/i,
                retainDiv:             /whois_record/i,
                agentName:             /mobile/i
    }
    function cleanHeaders(e) {
        for (var headerIndex = 1; headerIndex < 3; headerIndex+=1) {
            var headers = e.getElementsByTagName('h' + headerIndex);
            for (var i=headers.length-1; i >=0; i-=1) {
                if (getClassWeight(headers[i]) < 0 || getLinkDensity(headers[i]) > 0.33) {
                    headers[i].parentNode.removeChild(headers[i]);
                }
            }
        }
    }
    function clean(e, tag) {
        var targetList = e.getElementsByTagName( tag );
        var isEmbed    = (tag === 'object' || tag === 'embed');
        for (var y=targetList.length-1; y >= 0; y-=1) {
            if(isEmbed) {
                var attributeValues = "";
                for (var i=0, il=targetList[y].attributes.length; i < il; i+=1) {
                    attributeValues += targetList[y].attributes[i].value + '|';
                }
                if (attributeValues.search(regexps.videos) !== -1) {
                    continue;
                }
                if (targetList[y].innerHTML.search(regexps.videos) !== -1) {
                    continue;
                }
            }
            if(typeof(targetList[y]) !== 'undefined'
              && (tag === "iframe"
              || (targetList[y].src && targetList[y].src.indexOf("ad.naver.com") > -1))){
                var parent = targetList[y].parentNode;
                while(parent && parent.tagName !== "TABLE"){
                    parent = parent.parentNode;
                }
                if(parent){
                    parent.parentNode.removeChild(parent);
                    continue;
                }
            }
            if(tag === "textarea"){
                var paragraghElement = document.createElement("p");
                var textAreaElement = targetList[y];
                paragraghElement.innerHTML = textAreaElement.value;
                var parent = targetList[y].parentNode;
                parent.insertBefore(paragraghElement,textAreaElement);
                while(parent && parent.tagName !== "TABLE"){
                    parent = parent.parentNode;
                }
                if(parent){
                parent.parentNode.removeChild(parent);
                return;
                }
             }
            if(typeof(targetList[y]) !== 'undefined') {
                targetList[y].parentNode.removeChild(targetList[y]);
            }
        }
    }
    function cleanHTML5(e, tag) {
        var targetList = e.getElementsByTagName( tag );
        for (var y=targetList.length-1; y >= 0; y-=1) {
            targetList[y].parentNode.removeChild(targetList[y]);
        }
    }
    function cleanSelect(e, tag) {
        var targetList = e.getElementsByTagName( tag );
        for (var y=targetList.length-1; y >= 0; y-=1) {
            targetList[y].style.display = 'none';
        }
    }
    function getCharCount(e,s) {
        s = s || ",";
        return getInnerText(e).split(s).length-1;
    }
    function getClassWeight(e) {
        if (!flag_to_add_weight)
            return 0;
        var weight = 0;
        var isClassNegativeEvaluated = false;
        var isClassPositiveEvaluated = false;
        if (typeof(e.className) === 'string' && e.className !== '')
        {
            if(e.className.search(regexps.negative) !== -1) {
                isClassNegativeEvaluated = true;
                weight -= 25; }
            if(e.className.search(regexps.positive) !== -1) {
                isClassPositiveEvaluated = true;
                weight += 30; }
        }
        if (typeof(e.id) === 'string' && e.id !== '') {
            if(e.id.search(regexps.negative) !== -1 && !isClassNegativeEvaluated) {
                weight -= 25; }
            if(e.id.search(regexps.positive) !== -1 && !isClassPositiveEvaluated) {
                weight += 30; }
        }
        return weight;
    }
    function ChineseJapneseKorean(innerCharacter) {
        if (!innerCharacter || innerCharacter.length == 0) return false;
        var innerCharacterCode = innerCharacter.charCodeAt(0);
        if (innerCharacterCode > 11904 && innerCharacterCode < 12031) return true;
        if (innerCharacterCode > 12352 && innerCharacterCode < 12543) return true;
        if (innerCharacterCode > 12736 && innerCharacterCode < 19903) return true;
        if (innerCharacterCode > 19968 && innerCharacterCode < 40959) return true;
        if (innerCharacterCode > 44032 && innerCharacterCode < 55215) return true;
        if (innerCharacterCode > 63744 && innerCharacterCode < 64255) return true;
        if (innerCharacterCode > 65072 && innerCharacterCode < 65103) return true;
        if (innerCharacterCode > 131072 && innerCharacterCode < 173791) return true;
        if (innerCharacterCode > 194560 && innerCharacterCode < 195103) return true;
        return false;
    }
    function cleanConditionally(e, tag) {
        var tagsList      = e.getElementsByTagName(tag);
        var curTagsLength = tagsList.length;
        for (var i=curTagsLength-1; i >= 0; i-=1) {
            var toRemove      = false;
            var weight = getClassWeight(tagsList[i]);
            var contentScore = (typeof tagsList[i].readability !== 'undefined') ? tagsList[i].readability.contentScore : 0;
            if(weight+contentScore < 0) {
                if(tag === "div" || tag === "article") {
                    var readerDivClass5 = document.getElementsByClassName("view_cnt");
                    var readerDivClass6 = document.getElementById("description");
                    var readerDivComment = tagsList[i].className + tagsList[i].id;
                    if (readerDivComment.search(regexps.unlikelyCandidates) !== -1 ) {
                        tagsList[i].parentNode.removeChild(tagsList[i]);
                    }
                    if(readerDivClass5.length > 0) {
                        toRemove = false;
                    }
                    if(readerDivClass6!==null && readerDivClass6.innerHTML.length > 0) {
                        toRemove = false;
                    }
                } else {
                    tagsList[i].parentNode.removeChild(tagsList[i]);
                }
            }
            else if (contentScore === 0 && tag === "span"){
                if(tagsList[i].parentNode && tagsList[i].parentNode.className != "def_txt"){
                    if (e.getElementsByTagName("img") && tagsList[i].style.backgroundImage !== 'none'){
                        tagsList[i].parentNode.removeChild(tagsList[i]);
                    }
                }
            }
            else if ( getCharCount(tagsList[i],',') < 10) {
                var p      = tagsList[i].getElementsByTagName("p").length;
                var img    = tagsList[i].getElementsByTagName("img").length;
                var li     = tagsList[i].getElementsByTagName("li").length-100;
                var input  = tagsList[i].getElementsByTagName("input").length;
                var embedCount = 0;
                var embeds     = tagsList[i].getElementsByTagName("embed");
                for(var ei=0,il=embeds.length; ei < il; ei+=1) {
                    if (embeds[ei].src.search(regexps.videos) === -1) {
                        embedCount+=1;
                    }
                }
                var linkDensity   = getLinkDensity(tagsList[i]);
                var contentLength = getInnerText(tagsList[i]).length;
                var finalWord     = null;
                var checkCJK      = null;
                var checkCJKText  = null;
                var checkWordOfTag = function(){
                    checkCJKText = getInnerText(tagsList[i]);
                    for(var h = 0;h < contentLength; h +=1){
                        if(ChineseJapneseKorean(checkCJKText[h]) === true) {
                            finalWord = checkCJKText[h];
                            checkCJK  = true;
                            isTTSSupported = "false"; //TTS
                            break;
                        }
                    }
                    return finalWord;
                }
                if ( img > p && p != 0) {
                    toRemove = true;
                } else if(li > p && tag !== "ul" && tag !== "ol") {
                    toRemove = true;
                } else if( input > Math.floor(p/3) ) {
                    toRemove = true;
                } else if(contentLength < 25 && (img > 2 || img === 0) ) {
                    toRemove = true;
                } else if(weight < 25 && linkDensity > 0.2) {
                    toRemove = true;
                } else if(weight >= 25 && linkDensity > 0.5) {
                    toRemove = true;
                } else if((embedCount === 1 && contentLength < 75) || embedCount > 1) {
                    toRemove = true;
                }
                if((checkWordOfTag() !== 'undefined') && checkCJK && toRemove){
                    if(weight < 25 && linkDensity > 0.3){
                        toRemove = true;
                    }else {
                        toRemove = false;
                    }
                }
                var images     = tagsList[i].getElementsByTagName("img");
                for(var im=0,il=images.length; im < il; im+=1) {
                    images[im].removeAttribute("data-caption");
                    if ((images[im].height * images[im].width) >= 30000 ) {
                        toRemove = false;
                        break;
                    }
                    if (images[im].className === "nbd_im" ||(images[im].parentNode
                            && images[im].parentNode.className === "nbd_a")) {
                        toRemove = false;
                        break;
                    }
                    if(location.href.indexOf("nytimes.com") > -1){
                        var imgParent = images[im].parentNode;
                        if(imgParent && imgParent.parentNode && imgParent.parentNode.className && imgParent.parentNode.className.indexOf("imageholder") > -1){
                            toRemove = false;
                            break;
                        }
                        if(imgParent && imgParent.className && imgParent.className.indexOf("image-container") > -1){
                            toRemove = false;
                            break;
                        }
                    }
                }
                if(tag === "div" || tag === "article") {
                    var readerDivComment = tagsList[i].className + tagsList[i].id;
                    if (readerDivComment.search(regexps.unlikelyCandidates) !== -1 ) {
                        toRemove = true;
                    }
                    var readerDivClass = document.getElementsByClassName("whois_record");
                    if(readerDivClass.length > 0) {
                        toRemove = false;
                    }
                    var readerDivClass1 = document.getElementsByClassName("sixteen columns hreview hentry hnews full");
                    if(readerDivClass1.length > 0) {
                        toRemove = false;
                    }
                    var readerDivClass2 = document.getElementsByClassName("list");
                    if(readerDivClass2.length > 0) {
                        toRemove = false;
                    }
                    var readerDivClass5 = document.getElementsByClassName("view_cnt");
                    if(readerDivClass5.length > 0) {
                        toRemove = false;
                    }
                    var readerDivClass6 = document.getElementById("description");
                    if(readerDivClass6!==null && readerDivClass6.innerHTML.length > 0) {
                        toRemove = false;
                    }
                    if(tagsList[i].className === "pjuyo_new" || tagsList[i].id ==="ypolldiv"){
                        toRemove = true;
                    }
                }
                if(toRemove) {
                    tagsList[i].parentNode.removeChild(tagsList[i]);
                }
            }
        }
    }
    function killBreaks(e) {
        try {
            e.innerHTML = e.innerHTML.replace(regexps.killBreaks,'<br />');
        }
        catch (eBreaks) {
        }
    }
    function cleanStyles(e) {
        e = e || document;
        var cur = e.firstChild;
        if(!e) {
            return; }
        if(typeof e.removeAttribute === 'function' && e.className !== 'readability-styled') {
            e.removeAttribute('style'); }
        while ( cur !== null ) {
            if ( cur.nodeType === 1 ) {
                if(cur.className !== "readability-styled") {
                    cur.removeAttribute("style");
                }
                if(cur.type === "text/css") {
                    cur.parentNode.removeChild(cur);
                }
                cleanStyles( cur );
            }
            cur = cur.nextSibling;
        }
    }
    function cleanImages(articleContent){
        var images = articleContent.getElementsByTagName("img");
        var imagesLength = images.length;
        var IMG_MIN_HEIGHT = 70;
        var IMG_MIN_WIDTH = 70;
        for(var i=imagesLength-1;i>=0;i--){
            if(images[i].height < IMG_MIN_HEIGHT && images[i].width < IMG_MIN_WIDTH){
                images[i].parentNode.removeChild(images[i]);
            }
        }
    }
    function cleanLinkHrefs(e) {
        var links = e.getElementsByTagName("a");
        for(var i=0, il=links.length; i<il;i+=1)
        {
            if (links[i].getElementsByTagName("img")){
                cleanConditionally(links[i], "span");
            }
            links[i].removeAttribute("target");
            links[i].removeAttribute("data-caption");
            if(links[i].getAttribute("href") == "#"){
                links[i].removeAttribute("href");
            }
            var onclickAttr = links[i].getAttribute("onclick");
            if(onclickAttr){
                if(onclickAttr.indexOf("window.open(") >= -1){
                    links[i].removeAttribute("onClick");
                }
            }
        }
    }
    function cleanLinkHrefsForTranslation(e) {
        var links = e.getElementsByTagName("a");
        for(var i=0, il=links.length; i<il;i+=1)
        {
            links[i].removeAttribute("target");
            links[i].removeAttribute("href");
        }
    }
    function getActualLazyLoadingImages(articleContent){
        var images = articleContent.getElementsByTagName('img');
        for(var i=0;i<images.length;i++){
            var imgSrc = images[i].src
            if (imgSrc == "" || imgSrc.search("blank.gif") > -1 ||
                                            imgSrc.search("data:image") == 0) {
                if (images[i].getAttribute('data-src')) {
                    images[i].src = images[i].getAttribute('data-src');
                } else if(images[i].getAttribute('datasrc')) {
                    images[i].src = images[i].getAttribute('datasrc');
                }
            }
        }
    }
    function prepArticle(articleContent) {
        if(articleContent === null){
            return false;
        }
        articleContent.innerHTML = articleContent.innerHTML.replace(/&lt;/g,'<').replace(/&gt;/g,'>');
        cleanStyles(articleContent);
        cleanConditionally(articleContent, "form");
        clean(articleContent, "object");
        cleanHTML5(articleContent, "video");
        cleanHTML5(articleContent, "audio");
        cleanHTML5(articleContent, "svg");
        cleanHTML5(articleContent, "canvas")
        cleanSelect(articleContent, "select");
        if(articleContent.getElementsByTagName('h2').length === 1) {
            clean(articleContent, "h2");
        }
        clean(articleContent, "iframe");
        clean(articleContent, "script");
        clean(articleContent, "style");
        clean(articleContent, "textarea");
        clean(articleContent, "input");
        clean(articleContent, "\n");
        clean(articleContent, "noscript");
        clean(articleContent, "button");
        cleanLinkHrefs(articleContent);
        cleanHeaders(articleContent);
        if (location.href.indexOf("wikipedia.org/wiki/") === -1
                && location.href.indexOf("news.cnet.com") === -1) {
            cleanConditionally(articleContent, "tr");
            cleanConditionally(articleContent, "ul");
            cleanConditionally(articleContent, "div");
        }
        if (location.href.indexOf("wikipedia.org/wiki/") !== -1) {
            cleanConditionally(articleContent, "div");
        }
        var articleParagraphs = articleContent.getElementsByTagName('p');
        for(var i = articleParagraphs.length-1; i >= 0; i-=1) {
            var imgCount    = articleParagraphs[i].getElementsByTagName('img').length;
            var embedCount  = articleParagraphs[i].getElementsByTagName('embed').length;
            var objectCount = articleParagraphs[i].getElementsByTagName('object').length;
            articleParagraphs[i].removeAttribute("align");
            if(imgCount === 0 && embedCount === 0 && objectCount === 0 && getInnerText(articleParagraphs[i], false) === '') {
                articleParagraphs[i].parentNode.removeChild(articleParagraphs[i]);
            }
        }
        try {
            articleContent.innerHTML = articleContent.innerHTML.replace(/<br[^>]*>\s*<p/gi, '<p');
        }
        catch (e) {
        }
    }
    function getLinkDensity(e) {
        var links      = e.getElementsByTagName("a");
        var textLength = getInnerText(e).length;
        var linkLength = 0;
        for(var i=0, il=links.length; i<il;i+=1)
        {
            linkLength += getInnerText(links[i]).length;
        }
        return linkLength / textLength;
    }
    function initializeNode(node) {
        if(node === null){
            return false;
        }
        node.readability = {"contentScore": 0};
        switch(node.tagName) {
        case 'DIV':
            node.readability.contentScore += 5;
            break;
        case 'ARTICLE':
            if(node.className === "article group")
                node.readability.contentScore +=50;
            else
                node.readability.contentScore +=25;
            break;
        case 'PRE':
        case 'TD':
        case 'BLOCKQUOTE':
            node.readability.contentScore += 3;
            break;
        case 'ADDRESS':
        case 'OL':
        case 'UL':
        case 'DL':
        case 'DD':
        case 'DT':
        case 'LI':
        case 'FORM':
            node.readability.contentScore -= 3;
            break;
        case 'H1':
        case 'H2':
        case 'H3':
        case 'H4':
        case 'H5':
        case 'H6':
        case 'TH':
            node.readability.contentScore -= 5;
            break;
        }
        node.readability.contentScore += getClassWeight(node);
    }
    function getActualInnerText(node){
        if (node.parentNode && node.parentNode.tagName === 'SCRIPT')
            return "";
        if (node.nodeType == 3){
            return node.data;}
        var ActualInnerText = "";
        node = node.firstChild;
        while(node){
            ActualInnerText = ActualInnerText + getActualInnerText(node);
            node = node.nextSibling;
        }
        return ActualInnerText;
    }
    function getInnerText(e, normalizeSpaces) {
        var textContent    = "";
        if(typeof(e.textContent) === "undefined" && typeof(e.innerText) === "undefined") {
            return "";
        }
        normalizeSpaces = (typeof normalizeSpaces === 'undefined') ? true : normalizeSpaces;
        if (e.nodeType != 3) {
            clean(e, "script");
        }
        if (navigator.appName === "Microsoft Internet Explorer") {
            textContent = e.innerText.replace( regexps.trim, "" ); }
        else {
            textContent = getActualInnerText(e);
        }
        if(normalizeSpaces && typeof(textContent) !== "undefined") {
            return textContent.replace( regexps.normalize, " "); }
        else {
            return textContent; }
    }
    function grabArticle(argumentPage) {
        var CJK;
        readerPage = argumentPage ? argumentPage : document.body;
        if(readerPage !== null){
            readerPage = readerPage.cloneNode(true);
        } else {
            return;
        }
        var allElements = readerPage.getElementsByTagName('*');
        var node = null;
        var nodesToScore = [];
        for(var nodeIndex = 0; (node = allElements[nodeIndex]); nodeIndex+=1) {
            var unlikelyMatchString = node.className + node.id;
            if (unlikelyMatchString !== "undefined") {
                if (unlikelyMatchString.search(regexps.unlikelyCandidates) !== -1 && unlikelyMatchString.search(regexps.okMaybeItsACandidate) === -1 && node.tagName !== "BODY") {
                    if(unlikelyMatchString.search("comment") !== -1)
                        node.innerHTML = "";
                    continue;
                }
                if (location.origin.indexOf('yahoo.com') > -1) {
                    if(unlikelyMatchString.search("vp-container") !== -1
                            || unlikelyMatchString.search("skinny") !== -1
                            || unlikelyMatchString.search("RoundedCorners") !== -1
                            || unlikelyMatchString.search("playlist-wrap") !== -1) {
                        node.innerHTML = "";
                        continue;
                    }
                }
                if (location.origin.indexOf('m.sports.naver.com') > -1) {
                    if (unlikelyMatchString.search("end_comp") !== -1) {
                        node.innerHTML = '';
                        continue;
                    }
                }
            }
            if(GetStyle(node, "display") === "none"  || (GetStyle(node, "clip") === "rect(0px 0px 0px 0px)")){
                node.innerHTML = "";
                continue;
            }
            if (node.tagName === "P" || node.tagName === "UL" ||
                    ( (node.tagName === "TD") &&
                            (node.getElementsByTagName('TABLE').length === 0)) ||
                            node.tagName === "PRE" || node.tagName === "SECTION"
                            || node.tagName === "p" ||
                            node.tagName === "ul" || ( (node.tagName === "td") &&
                                    (node.getElementsByTagName('table').length === 0)) ||
                                    node.tagName === "pre"|| node.tagName === "section" )  {
                nodesToScore[nodesToScore.length] = node;
            }
            if(location.origin.indexOf("wowtv.co.kr") > -1 || location.origin.indexOf("www.people.com") > -1){
                if(node.tagName === "ARTICLE" || node.tagName === "article")
                    nodesToScore[nodesToScore.length] = node;
            }
            if(node.nodeType === 8){
                //added for removing comments
            }
            if (node.tagName === "DIV" || node.tagName === "div") {
                if (node.innerHTML.search(regexps.divToPElements) === -1) {
                    try {
                        var parent = node.parentNode;
                        var parentSpecs = parent.id + parent.className;
                        if(parentSpecs != undefined){
                            if (parentSpecs.search(regexps.unlikelyCandidates) !== -1 && parentSpecs.search(regexps.okMaybeItsACandidate) === -1 && node.tagName !== "BODY") {
                                continue;
                            }
                        }
                        nodesToScore[nodesToScore.length] = node;
                    }
                    catch(e) {
                    }
                }
                else
                {
                    for(var i = 0, il = node.childNodes.length; i < il; i+=1) {
                        var childNode = node.childNodes[i];
                        if(childNode.nodeType === 3) {
                            nodesToScore[nodesToScore.length] = childNode;
                        }
                        if(childNode.tagName === 'SPAN' || childNode.tagName === 'span'){
                            nodesToScore[nodesToScore.length] = childNode;
                        }
                    }
                }
            }
        }
        var candidates = [];
        for (var pt=0; pt < nodesToScore.length; pt+=1) {
            var parentNode      = nodesToScore[pt].parentNode;
            var grandParentNode = parentNode ? parentNode.parentNode : null;
            var innerText       = getInnerText(nodesToScore[pt]);
            if(!parentNode || typeof(parentNode.tagName) === 'undefined') {
                continue;
            }
            if(innerText.length < 30) {
                continue; }
            if(typeof parentNode.readability === 'undefined') {
                initializeNode(parentNode);
                candidates.push(parentNode);
            }
            if((grandParentNode && typeof(grandParentNode.readability) === 'undefined' && typeof(grandParentNode.tagName) !== 'undefined')) {
                initializeNode(grandParentNode);
                candidates.push(grandParentNode);
            }
            var contentScore = 0;
            contentScore+=1;
            contentScore += innerText.split(',').length;
            var innerTextLength = 0;
            for (var i = 0; i < innerText.length; i++) {
                innerCharacter = innerText[i];
                if (ChineseJapneseKorean(innerCharacter) == true)
                {
                    innerTextLength++;
                    CJK = true;
                }
            }
            if(CJK) {
                contentScore += Math.min(Math.floor(innerText.length / 100), 3);
                contentScore = contentScore * 3;
            }
            else
            {
                if(innerText.length < 25) {
                    continue;
                }
                contentScore += Math.min(Math.floor(innerText.length / 100), 3);
            }
            parentNode.readability.contentScore += contentScore;
            if(grandParentNode) {
                grandParentNode.readability.contentScore += contentScore/2;
            }
        }
        var topCandidate = null;
        for(var c=0, cl=candidates.length; c < cl; c+=1)
        {
            var actualEl = getActualElInDOM( candidates[c]);
            if(actualEl){
                var el_width = actualEl.getBoundingClientRect().width;
                if(el_width <= 0){
                    continue;
                }
            }
            candidates[c].readability.contentScore = candidates[c].readability.contentScore * (1-getLinkDensity(candidates[c]));
            if(!topCandidate || candidates[c].readability.contentScore > topCandidate.readability.contentScore) {
                if((location.origin.indexOf("bbc.com") > -1) || (location.origin.indexOf("bbc.co.uk") > -1)){
                    if(!topCandidate){
                        topCandidate = candidates[c];
                    }
                    else if((candidates[c].style.display != "none") && (candidates[c].innerText.length > topCandidate.innerText.length)){
                        topCandidate = candidates[c];
                    }
                }else{
                    topCandidate = candidates[c];
                }
            }
        }
        var all_images_data = document.getElementsByTagName("img");
        for(var im=0,il=all_images_data.length; im < il; im+=1) {
            var img = all_images_data[im];
            var iId = img.id;
            var iSrc = img.src;
            var height = img.height;
            var width = img.width;
            if(height > 0 && width > 0){
                if(iId !== "") {
                    all_images_data_map_height[iId] = height;
                    all_images_data_map_width[iId] = width;
                }
                else if (all_images_data_map_height[iSrc] == undefined ) {
                    if (iSrc == "" || iSrc.search("blank.gif") > -1 ||
                                              iSrc.search("data:image") == 0) {
                        if (img.getAttribute('data-src')) {
                            iSrc = img.getAttribute('data-src');
                        } else if(img.getAttribute('datasrc')) {
                            iSrc = img.getAttribute('datasrc');
                        }
                    }
                    if (iSrc != "") {
                        all_images_data_map_height[iSrc] = height;
                        all_images_data_map_width[iSrc] = width;
                    }
                }
            }
        }
        if(location.origin.indexOf('hankooki.com') > -1){
            var tc = findTopCandidateInPage("gisa_contents");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if(location.origin.indexOf('post.naver.com') > -1){
            var tc = findTopCandidateByClass("sect_dsc");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if(location.origin.indexOf('wikipedia.org') > -1){
            var tc = findTopCandidateInPage("content");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if(location.origin.indexOf('m.sbs.co.kr') > -1){
            var tc = findTopCandidateByClass("view_detail");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if(location.origin.indexOf('imdb.com') > -1){
            var tc = findTopCandidateByClass("container");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if (location.origin.indexOf('downloadcenter.samsung.com') > -1) {
            var tc = findTopCandidateInPage("container");
            if(tc){
                topCandidate = tc;
                initializeNode(topCandidate);
            }
        }
        if (location.origin.indexOf('fakty.interia.pl') > -1
            || location.origin.indexOf('m.interia.pl') > -1) {
                var tc = findTopCandidateByClass("main-content");
                if (tc) {
                    topCandidate = tc;
                    initializeNode(topCandidate);
                }
            }
        if (topCandidate === null || topCandidate.tagName === "BODY")
        {
            topCandidate = document.createElement("DIV");
            topCandidate.innerHTML = readerPage.innerHTML;
            readerPage.innerHTML = "";
            readerPage.appendChild(topCandidate);
            initializeNode(topCandidate);
        }
        var articleContent = null;
        if(location.origin == "http://edition.cnn.com" || (location.origin.indexOf("yahoo.com") > -1)){
            articleContent = SearchLevelHigher(5, topCandidate, readerPage);
        }
        else{
            articleContent = SearchLevelHigher(1, topCandidate, readerPage);
        }
        getActualLazyLoadingImages(articleContent);
        prepArticle(articleContent);
     if (getInnerText(articleContent, false).length < 250) {
        if (flag_to_add_weight) {
            flag_to_add_weight = false;
            return grabArticle(document.body);
        }
    }
        for (var pt=0; pt < nodesToScore.length; pt+=1) {
            var parentNode      = nodesToScore[pt].parentNode;
            var grandParentNode = parentNode ? parentNode.parentNode : null;
            if (parentNode){
                delete parentNode.readability;
            }
            if (grandParentNode) {
                delete grandParentNode.readability;
            }
        }
        if( articleContent.innerHTML == '' )
        {
            return " " ;
        }
        return articleContent.innerHTML;
    }
    function findTopCandidateInPage(elId){
        if(document.getElementById(elId)){
            return document.getElementById(elId);
        }
    }
    function findTopCandidateByClass(elCls){
        if(document.getElementsByClassName(elCls))
            return document.getElementsByClassName(elCls)[0];
    }
    function getActualElInDOM(el){
        var actualEl = null;
        var id = el.id;
        var classes = el.className;
        if(id && id.length > 0){
            actualEl = document.getElementById(id);
        }else if(classes && classes.length > 0){
            actualEl = document.getElementsByClassName(classes)[0];
        }
        return actualEl;
    }
    function SearchLevelHigher(Levels, topCandidate, page){
        var articleContent        = document.createElement("DIV");
        articleContent.id     = "readability-content";
        var topCandidateCheckNode = topCandidate;
        for (var x = -1; x < Levels; x++){
            var siblingScoreThreshold = Math.max(10, topCandidate.readability.contentScore * 0.2);
            var siblingNodes          = topCandidateCheckNode.parentNode? topCandidateCheckNode.parentNode.childNodes : null;
            var otherElementImageSearchToProceed = true;
            for(var s=0; siblingNodes && s < siblingNodes.length; s+=1) {
                var siblingNode = siblingNodes[s];
                var append      = false;
                if(!siblingNode) {
                    continue;
                }
                if(siblingNode === topCandidate)
                {
                    append = true;
                    otherElementImageSearchToProceed = false;
                }
                else if (siblingNode === topCandidateCheckNode)
                    otherElementImageSearchToProceed = false;
                var contentBonus = 0;
                if(siblingNode.className === topCandidate.className && topCandidate.className !== "") {
                    contentBonus += topCandidate.readability.contentScore * 0.2;
                }
                if(typeof siblingNode.readability !== 'undefined' && topCandidate.className !== "" && siblingNode.className === topCandidate.className && (siblingNode.readability.contentScore+contentBonus) >= siblingScoreThreshold)
                {
                     append = true;
                }
                if(siblingNode.nodeName === "P" && topCandidate.className !== "" && siblingNode.className === topCandidate.className ) {
                    var linkDensity = getLinkDensity(siblingNode);
                    var nodeContent = getInnerText(siblingNode);
                    var nodeLength  = nodeContent.length;
                    if(nodeLength > 80 && linkDensity < 0.25)
                    {
                        append = true;
                    }
                    else if(nodeLength < 80 && linkDensity === 0 && nodeContent.search(/\.( |$)/) !== -1)
                    {
                        append = true;
                    }
                }
                if (!append && otherElementImageSearchToProceed){
                    var anyImagesToAdd = isImageWorthySiblingNode(siblingNode, page);
                    if (anyImagesToAdd !== false){
                        if (articleContent.childElementCount === 0)
                            articleContent.appendChild(anyImagesToAdd.cloneNode(false));
                        else
                            articleContent.insertBefore(anyImagesToAdd.cloneNode(false), articleContent.childNodes[0]);
                    }
                }
                if(append) {
                    var nodeToAppend = null;
                    if(siblingNode.nodeName !== "DIV" && siblingNode.nodeName !== "P") {
                        nodeToAppend = document.createElement("DIV");
                        try {
                            nodeToAppend.id = siblingNode.id;
                            nodeToAppend.innerHTML = siblingNode.innerHTML;
                        }
                        catch(er) {
                            nodeToAppend = siblingNode;
                            s-=1;
                            sl-=1;
                        }
                    } else {
                        nodeToAppend = siblingNode;
                    }
                    articleContent.appendChild(nodeToAppend.cloneNode(true));
                }
            }
            if(topCandidateCheckNode.parentNode)
                topCandidateCheckNode = topCandidateCheckNode.parentNode;
        }
        return articleContent;
    }
    function isImageWorthySiblingNode(node, page){
        if (!node || node.nodeType === 3 || node.nodeType === 8)
            return false;
        var ImageContents = node.getElementsByTagName("IMG");
        var returnValue = false;
        var Index = -1;
        var pageElements  = page.getElementsByTagName('*');
        for (var x =0; x < pageElements.length; x++){
            if (pageElements[x] === node)
                Index = x;
        }
        var pageOwnerDocumentElements = page.ownerDocument.body.getElementsByTagName('*');
        var inlineIndentationFloat = GetStyle(pageOwnerDocumentElements[Index], "float");
        var inlineIndentationDisplay = GetStyle(pageOwnerDocumentElements[Index], "display");
        for (var i = 0, icl = ImageContents.length ; i < icl; i++){
            if (ImageContents[i].src.search("adimg.daumcdn.net") > -1 || ImageContents[i].src.search("news_00000_insight") > -1 || ((location.href.indexOf("m.huffpost.com") > -1) && ImageContents[i].className === "headshot")) {
                continue;
            }
            if(location.href.indexOf("nytimes.com") > -1){
                var imgParent = ImageContents[i].parentNode;
                if(imgParent && imgParent.parentNode && imgParent.parentNode.className && imgParent.parentNode.className.indexOf("imageholder") > -1){
                    returnValue = ImageContents[i];
                }
                if(imgParent && imgParent.className && imgParent.className.indexOf("image-container") > -1){
                    returnValue = ImageContents[i];
                }
            }
            if (inlineIndentationFloat && (inlineIndentationFloat === "right" || inlineIndentationFloat === "left")){
                if (ImageContents[i].width * ImageContents[i].height >= 40000)
                    returnValue = ImageContents[i];
            }
            else if (inlineIndentationFloat && inlineIndentationFloat === "none" && (inlineIndentationDisplay === "block" || inlineIndentationDisplay === "inline")
                    && (ImageContents[i].width * ImageContents[i].height >= 14000) && ImageContents[i].height > 100){
                returnValue = ImageContents[i];
            }
        }
        return returnValue;
    }
    function GetStyle(Element, CssProperty){
        var strValue = "";
        if (!Element)
            return strValue;
        if (readerPage.ownerDocument.defaultView && readerPage.ownerDocument.defaultView.getComputedStyle && readerPage.ownerDocument.defaultView.getComputedStyle(Element, ""))
            strValue = readerPage.ownerDocument.defaultView.getComputedStyle(Element, "").getPropertyValue(CssProperty);
        return strValue;
    }
    function getArticleTitle() {
        var curTitle = "",
                origTitle = "";
        try {
            curTitle = origTitle = document.title;
            if(typeof curTitle !== "string") {
                curTitle = origTitle = getInnerText(document.getElementsByTagName('title')[0]);
            }
        }
        catch(e) {}
        curTitle = cleanUpTitleCandidate(curTitle);
        if(curTitle.length > 150 || curTitle.length < 15)
        {
            var hOnes = document.getElementsByTagName('h1');
            if(hOnes.length === 1)
            {
                curTitle = getInnerText(hOnes[0]);
            }
        }
        curTitle = curTitle.replace( regexps.trim, "" );
        if(curTitle.split(' ').length <= 4) {
            curTitle = origTitle;
        }
        try{
            var metaTitle = null;
            var metaElements = [];
            metaElements = document.getElementsByTagName('meta');
            var resultProp = null, resultName = null, resultid = null;
            for (var i=0, ml = metaElements.length; i < ml; i+=1){
                if (metaElements[i]){
                    resultProp = (metaElements[i].getAttribute('property'))? (metaElements[i].getAttribute('property').toLowerCase().indexOf('title')!== -1) : null;
                    resultName = (metaElements[i].getAttribute('name'))? (metaElements[i].getAttribute('name').toLowerCase().indexOf('title')!== -1) : null;
                    resultid = (metaElements[i].getAttribute('id'))? (metaElements[i].getAttribute('id').toLowerCase().indexOf('title')!== -1) : null;
                    if (resultProp || resultName || resultid){
                        metaTitle = metaElements[i].getAttribute('content');
                    }
                }
            }
            if (!metaTitle)
                return curTitle;
            else{
                metaTitle = cleanUpTitleCandidate(metaTitle);
                metaTitle = metaTitle.replace(regexps.trim, "");
                return metaTitle.length > curTitle.length ? metaTitle : curTitle;
            }
        }
        catch (e) {
            return curTitle;
        }
    }
    function cleanUpTitleCandidate(Title){
        var curTitle = "", origTitle = "";
        curTitle = origTitle = Title;
        if(curTitle.match(/ [\|\-] /))
        {
            curTitle = origTitle.replace(/(.*)[\|\-] .*/gi,'$1');
            if(curTitle.split(' ').length < 3) {
                curTitle = origTitle.replace(/[^\|\-]*[\|\-](.*)/gi,'$1');
            }
        }
  return curTitle;
    }
    function adjustTableSize(content) {
        var page_width = screen.availWidth;
        var table_width = 0;
        var all_tables = content.getElementsByTagName("table");
        for(var i =0; i < all_tables.length;i+=1) {
            table_width = all_tables[i].getBoundingClientRect().width;
            if(table_width > page_width){
                var tdCount = all_tables[i].getElementsByTagName("td").length;
                if(tdCount > 2){
                    all_tables[i].outerHTML = "<div style='width:100%;overflow-x:scroll;'>"+all_tables[i].outerHTML+"</div>";
                }else{
                    all_tables[i].style.width = "100%";
                }
            }
        }
    }
    function adjustImageSizeForFirstPage(content) {
        var figureElements =  content.getElementsByTagName("figure");
        for (var i=0,il2=figureElements.length; i < il2; i+=1) {
            var fE = figureElements[i];
            if (fE != undefined) {
                var img_element = fE.getElementsByTagName("img");
                if (img_element.length === 0 && fE.innerText === "") {
                    fE.parentNode.removeChild(fE);
                } else {
                    figureElements[i].style.margin = "0px";
                }
            }
        }
        var all_images = content.getElementsByTagName("img");
        for(var im=0,il=all_images.length; im < il; im+=1) {
            var img = all_images[im];
            var image_src = img.src;
            var image_id = img.id;
            var image_width = 0;
            var image_height = 0;
            if (image_id != "") {
                image_width = all_images_data_map_width[image_id];
                image_height = all_images_data_map_height[image_id];
            }
            else if (image_src != "") {
                image_width = all_images_data_map_width[image_src];
                image_height = all_images_data_map_height[image_src];
            }
            var imgStyle = window.getComputedStyle(img);
            if (imgStyle.display === 'none' || imgStyle.display === 'hidden') {
                img.style.display = 'none';
                continue;
            }
            if (image_src.search(regexps.images) === -1) {
                var page_width = screen.availWidth;
                var page_height = screen.availHeight;
                var space = page_width - image_width;
                var page_margin_left = space/2;
                page_margin_left -= 10;
                var isLandscape = false;
                if (page_height < page_width)
                    isLandscape = true;
                img.style.marginTop="1px";
                img.style.marginBottom="1px";
                img.align="center";
                img.style.marginLeft= "auto";
                img.style.marginRight= "auto";
                img.style.display= "block";
                var spaceAvailableW = page_width - 24;
                var spaceAvailableH = page_height - 24;
                if (navUserAgent.search(regexps.agentName) === -1) {
                    spaceAvailableW = page_width - 96;
                    spaceAvailableH = page_height - 96;
                }
                if (image_width < 65 || image_height < 65) {
                    img.style.display= "none";
                }
                else if (image_id.indexOf("rmcPlayer_") === 0) {
                    img.style.display= "none";
                }
                else if ((image_width > spaceAvailableW)
                           ||(isLandscape && (image_width > spaceAvailableH))) {
                    img.removeAttribute("width");
                    img.style.width= "100%";
                    img.removeAttribute("height");
                }
                else {
                    if (image_height == undefined || image_width == undefined) {
                        if ((img.width > spaceAvailableW)
                            ||(isLandscape && (img.width > spaceAvailableH))) {
                            img.removeAttribute("width");
                            img.style.width= "100%";
                            img.removeAttribute("height");
                        } else {
                            img.style.width= img.width + 'px';
                            img.style.height = img.height + 'px';
                        }
                    } else {
                        img.style.height = image_height +'px';
                        img.style.width = image_width +'px';
                    }
                }
            }
        }
    }
    function mapTableToDivEls(content){
        var htmlContent='';
        var trEl = content.getElementsByTagName("tr");
        for(var a=0;a<trEl.length;a++){
            htmlContent += '<div style="width:100%;">';
            var tdEl = trEl[a].getElementsByTagName("td");
            for( var k=0;k<tdEl.length;k++){
                if(tdEl[k].innerHTML != undefined)
                    htmlContent += '<div>' + tdEl[k].innerHTML+'</div>';
                else
                    htmlContent += '<div></div>';
            }
            htmlContent += '</div>';
        }
        return htmlContent;
    }
    function escapeHtml(unsafe) {
        return unsafe
                .replace(/&/g, "&amp;")
                .replace(/</g, "&lt;")
                .replace(/>/g, "&gt;")
                .replace(/"/g, "&quot;")
                .replace(/\//g, "&#047;")
                        .replace(/'/g, "&#039;");
    }
    function initReader() {
        isTTSSupported = "true";
        var sflBody;
        var ttsContent;
        var articleHeader;
        var back_image = "url(http://www.commentnation.com/backgrounds/images/white_paper_texture_background_seamless_pattern.jpg)";
        var reader_div = document.createElement("div");
        reader_div.id  = "reader_div";
        reader_div.style.display="none";
        var article_block = grabArticle();
        if (article_block) {
            parsedPages[window.location.href.replace(/\/$/, '')] = true;
            var allPageLink;
            var nextPageLink = findNextPageLink(readerPage);
            var parameters;
            if(nextPageLink) {
                parameters= nextPageLink+","+ window.location.protocol + window.location.host +window.location.pathname ;
            }else
                parameters = null;
            var reader_domain_div = document.createElement("div");
            var reader_title_div = document.createElement("div");
            reader_title_div.style.wordWrap = "break-word";
            var reader_header = getArticleTitle();
            var reader_domain_name = document.domain;
            if(reader_header === ""){
                articleHeader = document.location.hostname;
            }else{
                articleHeader = escapeHtml(reader_header);
            }
            reader_title_div.innerHTML = "<div id='article_header' class='BSB_header'>"+articleHeader+"</div>";
            reader_div.appendChild(reader_title_div);
            reader_domain_div.innerHTML = "<div id='article_domain_name' class='BSB_domain_name'>"+reader_domain_name+"</div>";
            reader_div.appendChild(reader_domain_div);
            var reader_content_div = document.createElement("div");
            reader_content_div.id = "reader_content_div";
            if(curPageNum === 1 && nextPageLink === null){
                reader_content_div.innerHTML = '<div id="readability-page-1" class="BSB_page"><p class="BSB_page-separator" title="No Page"></p>'+article_block+'</div>';
            }else {
                reader_content_div.innerHTML = '<div id="readability-page-1" class="BSB_page"><div class="BSB_page-separator"><span class="BSB_page-num" title="Page ' + curPageNum + '">Page '+curPageNum+' of </span><span id="page" class="BSB_page-total">'+totalPageNum+'</span></div>'+article_block+'</div>';
            }
            sflBody = reader_content_div.innerText;
            reader_div.appendChild(reader_content_div);
            ttsContent = reader_div.innerText;
            adjustImageSizeForFirstPage(reader_div);
            adjustTableSize(reader_div);
            var readerArticleForTranslation  = reader_div.cloneNode(true);
            var readerArticleForTranslationText = readerArticleForTranslation.innerHTML;
            reader_content_div.outerHTML += parameters;
        }
        return reader_div.innerHTML;
    }
    initReader();
}
catch(e) {
}